<?php # $Id: serendipity_rss_exchange.inc.php,v 1.13 2004/10/20 16:27:23 tomsommer Exp $

require_once 'bundled-libs/Onyx/RSS.php';

function serendipity_rss_buildEntry($item, &$entry)
{
    global $serendipity;

    $entry    = array();
    $bodyonly = (isset($serendipity['POST']['bodyonly']) && $serendipity['POST']['bodyonly'] == 'true' ? true : false);

    if ($item['description']) {
        $entry['body'] = utf8_decode($item['description']);
    }

    if ($item['content:encoded']) {
        if (!isset($entry['body']) || $bodyonly) {
            $data = &$entry['body'];
        } else {
            $data = &$entry['extended'];
        }

        // See if the 'description' element is a substring of the 'content:encoded' part. If it is,
        // we will only fetch the full 'content:encoded' part. If it's not a substring, we append
        // the 'content:encoded' part to either body or extended entry (respecting the 'bodyonly'
        // switch). We substract 4 letters because of possible '...' additions to an entry.
        $testbody = substr(trim(strip_tags($entry['body'])), 0, -4);
        if ($testbody != substr(trim(strip_tags($item['content:encoded'])), 0, strlen($testbody))) {
            $data .= utf8_decode($item['content:encoded']);
        } else {
            $data = utf8_decode($item['content:encoded']);
        }
    }

    $entry['title'] = utf8_decode($item['title']);
    $entry['timestamp'] = utf8_decode(strtotime(isset($item['pubdate']) ? $item['pubdate'] : $item['dc:date']));
    if ($entry['timestamp'] == -1) {
        $entry['timestamp'] = time();
    }

    if ($serendipity['POST']['type'] == 'draft') {
        $entry['isdraft'] = 'true';
    } else {
        $entry['isdraft'] = 'false';
    }

    if (!empty($item['category'])) {
        $cat = serendipity_fetchCategoryInfo(0, trim(utf8_decode($item['category'])));
        if (is_array($cat) && isset($cat['categoryid'])) {
            $entry['categories'][] = $cat['categoryid'];
        }
    }

    if (!is_array($entry['categories'])) {
        $entry['categories'][] = $serendipity['POST']['category'];
    }

    if (!isset($entry['extended'])) {
        $entry['extended'] = '';
    }

    $entry['allow_comments'] = true;

    return true;
}

function serendipity_rss_import($url)
{
    global $serendipity;

    $c = &new Onyx_RSS();
    $c->parse($url);

    $serendipity['noautodiscovery'] = 1;
    while ($item = $c->getNextItem()) {
        if (serendipity_rss_buildEntry($item, $entry)) {
            serendipity_updertEntry($entry);
        }
    }

    return true;
}

/* vim: set sts=4 ts=4 expandtab : */
?>